<!doctype html>
<html lang="es">

<head>
  <meta charset='utf-8'>
  <title>Estilos: Combinar Selectores</title>
  <link rel='stylesheet' href='css/style.css'>
  <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>

  <article class='reveal'>

    <section data-bespoke-state='portada'>
      <h1>Estilos: Combinar Selectores</h1>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Agrupar selectores</h2>
      <pre><code><span class="selector">selector1</span>, <span class="selector">selector2</span></code></pre>
      <ul class="lista">
        <li>Varios selectores separados por comas</li>
        <li>Asigna las propiedades a todos los selectores</li>
        <li>Permite reducir los css</li>
      </ul>
      <h3>Ejemplo</h3>      
      <pre><code><span class="selector">h1</span>, <span class="selector">.importante</span> {
  <span class="propiedad">font-weight:</span> <span class="valor-css">bold;</span>
  <span class="propiedad">text-decoration:</span> <span class="valor-css">underline;</span>
}</code></pre>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Acotar selectores</h2>
      <pre><code><span class="selector">selector1</span>[.#]<span class="selector">selector2</span></code></pre>
      <ul class="lista">
        <li>Varios selectores sin separación</li>
        <li>Tiene que cumplir todas las condiciones</li>
        <li>Solo un id y una etiqueta</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">.error</span> {
  <span class="propiedad">color:</span> <span class="valor-css">red;</span>
  <span class="propiedad">font-weight:</span> <span class="valor-css">bold;</span>
}
<span class="selector">div</span><span class="selector">.error</span> {
  <span class="propiedad">border:</span> <span class="valor-css">1px solid red;</span>
}</code></pre>
        <iframe src="./ejemplos/p14_acotar_selectores.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Seleccionar descendientes</h2>
      <pre><code><span class="selector">selector1</span> <span class="selector">selector2</span></code></pre>
      <ul class="lista">
        <li>Varios selectores separados por espacio</li>
        <li>Las propiedades aplican al último selector</li>
        <li>Tiene que ser descendiente del selector de la izquierda</li>
        <li>Puede haber etiquetas intermedias</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">.lista-ejemplo</span> <span class="selector">li</span> {
  <span class="propiedad">border:</span> <span class="valor-css">1px solid;</span>
}</code></pre>
        <iframe src="./ejemplos/p14_seleccionar_descendientes.html"></iframe>
      </div>

    </section>

    <section data-bespoke-state='clean'>
      <h2>Seleccionar hijos</h2>
      <pre><code><span class="selector">selector1</span> > <span class="selector">selector2</span></code></pre>
      <ul class="lista">
        <li>Varios selectores separados por <strong>></strong></li>
        <li>Las propiedades aplican al último selector</li>
        <li>Tiene que ser hijo del selector de la izquierda</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">.lista-ejemplo</span> > <span class="selector">li</span> {
  <span class="propiedad">border:</span> <span class="valor-css">1px solid;</span>
}</code></pre>
        <iframe src="./ejemplos/p14_seleccionar_hijos.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Seleccionar consecutivos</h2>
      <pre><code><span class="selector">selector1</span> + <span class="selector">selector2</span></code></pre>
      <ul class="lista">
        <li>Varios selectores separados por <strong>+</strong></li>
        <li>Las propiedades aplican al último selector</li>
        <li>Tiene que ser el siguiente elemento al selector de la izquierda</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">p</span> + <span class="selector">p</span> {
  <span class="propiedad">color:</span> <span class="valor-css">red;</span>
  <span class="propiedad">font-weight:</span> <span class="valor-css">bold;</span>
}</code></pre>
        <iframe src="./ejemplos/p14_seleccionar_consecutivos.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Seleccionar hermanos pequeños</h2>
      <pre><code><span class="selector">selector1</span> ~ <span class="selector">selector2</span></code></pre>
      <ul class="lista">
        <li>Varios selectores separados por <strong>~</strong></li>
        <li>Las propiedades aplican al último selector</li>
        <li>Tiene que cumplir que tenga un hermano mayor como el selector1</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">p</span> ~ <span class="selector">p</span> {
  <span class="propiedad">color:</span> <span class="valor-css">red;</span>
  <span class="propiedad">font-weight:</span> <span class="valor-css">bold;</span>
}</code></pre>
        <iframe src="./ejemplos/p14_seleccionar_hermanos_pequenyos.html"></iframe>
      </div>
    </section>

    <section class="no-print pt-2" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Aplicar anchura de <span class="valor-css">60%</span> al <span class="etiqueta">main</span></li>
        <li>Aplicar margen de <span class="valor-css">.4rem</span> a las secciones de "Zona Divs" y "Zona Listas"</li>
        <li>Asignar borde de <span class="valor-css">1px solid green</span> y margen <span class="valor-css">.4rem</span> a todos los <span class="etiqueta">div</span> descendientes de <span class="selector">abuelo</span> (div abuelo y ul de zona listas)</li>
        <li>Asignar borde de <span class="valor-css">1px solid red</span> a los <span class="etiqueta">div</span> hijos de <span class="selector">abuelo</span></li>
        <li>Asignar borde de <span class="valor-css">1px solid blue</span> a todos los <span class="etiqueta">div</span> precedidos por un <span class="etiqueta">h2</span></li>
        <li>Asignar color de fondo <span class="valor-css">azure</span> a todos los <span class="etiqueta">div</span> hijos de un <span class="etiqueta">li</span></li>
        <li>Asignar color de fondo <span class="valor-css">gray</span> a todos los <span class="etiqueta">li</span> descendientes de un <span class="etiqueta">div</span> cuyo padre sea un <span class="etiqueta">li</span></li>
        <li>Asignar color de fondo <span class="valor-css">pink</span> a todos los <span class="etiqueta">div</span> que tengan un hermano mayor de tipo span</li>
      </ul>      
      <p class="text-center">
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio24/index.html?inline=false">Ejercicio</a>
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio24/img/resultado.png?inline=false">Resultado</a>
      </p>
    </section>
  </article>

  <script src='js/slides.keys.js'></script>
  <script src='js/slides.classes.js'></script>
  <script src='js/slides.state.js'></script>
  <script src='js/slides.kernel.js'></script>
  <script src='js/slides.jump.js'></script>
  <script src='js/slides.swipe.js'></script>

  <script>
    const { Deck, classes, keys, state, jump, swipe } = S6;
    const deck = new Deck({
      parent: 'article',
      plugins: [classes(), keys(), state(), jump(), swipe()]
    });
  </script>
</body>

</html>